## Update a customer

### cURL

```bash
curl --request PATCH \
  --url https://api.withflex.com/v1/customers/{id} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "customer": {
    "first_name": "John",
    "last_name": "Doe",
    "email": "joh.doe@example.com",
    "phone": "+15555555555",
    "employer": "Flex",
    "shipping": {},
    "metadata": "{\"key\": \"value\"}"
  }
}
' 
```

### Python

```python
import requests

url = "https://api.withflex.com/v1/customers/{id}"

payload = { "customer": {
        "first_name": "John",
        "last_name": "Doe",
        "email": "joh.doe@example.com",
        "phone": "+15555555555",
        "employer": "Flex",
        "shipping": {},
        "metadata": "{\"key\": \"value\"}"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch API)

```javascript
const options = {
  method: 'PATCH',
  headers: { Authorization: 'Bearer <token>', 'Content-Type': 'application/json' },
  body: JSON.stringify({
    customer: {
      first_name: 'John',
      last_name: 'Doe',
      email: 'joh.doe@example.com',
      phone: '+15555555555',
      employer: 'Flex',
      shipping: {},
      metadata: '{"key": "value"}'
    }
  })
};

fetch('https://api.withflex.com/v1/customers/{id}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```php
$curl = curl_init();
curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.withflex.com/v1/customers/{id}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PATCH",
  CURLOPT_POSTFIELDS => json_encode([
    'customer' => [
        'first_name' => 'John',
        'last_name' => 'Doe',
        'email' => 'joh.doe@example.com',
        'phone' => '+15555555555',
        'employer' => 'Flex',
        'shipping' => [],
        'metadata' => '{"key": "value"}'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.withflex.com/v1/customers/{id}"

payload := strings.NewReader("{\n  \"customer\": {\n    \"first_name\": \"John\",\n    \"last_name\": \"Doe\",\n    \"email\": \"joh.doe@example.com\",\n    \"phone\": \"+15555555555\",\n    \"employer\": \"Flex\",\n    \"shipping\": {},\n    \"metadata\": \"{\\\"key\\\": \\\"value\\\"}\"\n  }\n}")

req, _ := http.NewRequest("PATCH", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

d	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Unirest

```java
HttpResponse<String> response = Unirest.patch("https://api.withflex.com/v1/customers/{id}")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"customer\": {\n    \"first_name\": \"John\",\n    \"last_name\": \"Doe\",\n    \"email\": \"joh.doe@example.com\",\n    \"phone\": \"+15555555555\",\n    \"employer\": \"Flex\",\n    \"shipping\": {},\n    \"metadata\": \"{\\\"key\\\": \\\"value\\\"}\"\n  }\n}")
  .asString();
```

### Ruby

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.withflex.com/v1/customers/{id}")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"customer\": {\n    \"first_name\": \"John\",\n    \"last_name\": \"Doe\",\n    \"email\": \"joh.doe@example.com\",\n    \"phone\": \"+15555555555\",\n    \"employer\": \"Flex\",\n    \"shipping\": {},\n    \"metadata\": \"{\\\"key\\\": \\\"value\\\"}\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

### Response Codes

- **200**: Successful update of customer.
- **401**: Unauthorized access - invalid token.
- **403**: Forbidden access.
- **404**: Customer not found.
- **409**: Conflict with existing resource.
- **422**: Unprocessable Entity.
- **429**: Too Many Requests.

### Example of a Successful Response
```json
{
  "customer": {
    "customer_id": "fcus_01HACM7FZ1084XB1GB6053VM0D",
    "owner_partner_id": "obj_01J9XR8M3K7VZ8N2YB4WJ6T0RA",
    "first_name": "John",
    "last_name": "Doe",
    "email": "joh.doe@example.com",
    "phone": "+15555555555",
    "employer": "Flex",
    "shipping": {},
    "metadata": {
      "order_id": "8842",
      "channel": "shopify"
    },
    "created_at": "2026-06-15T14:30:00Z",
    "test_mode": false
  }
}
```

### Error Response Format
```json
{
  "code": "string",
  "detail": "string"
}
```

### Request Parameters
- **id** (string, required): The ID of the customer to update. Example: "fcus_01J9XR8M3K7VZ8N2YB4WJ6T0RA".

### Request Body
The body must be in **application/json** format and contain a `customer` object, which is required. Example:
```json
{
  "customer": {
    "first_name": "John",
    "last_name": "Doe",
    "email": "joh.doe@example.com",
    "phone": "+15555555555",
    "employer": "Flex",
    "shipping": {
      "line1": "123 Main St",
      "line2": "Suite 100",
      "city": "San Francisco",
      "state": "CA",
      "postal_code": "94107",
      "country": "US"
    },
    "metadata": "{\"key\": \"value\"}"
  }
}
```

### Example of a Successful Response Body
```json
{
  "customer": { ... }
}
```
